# an example of spherical K-means, not efficient and has to be improved further (to be replaced)
# matplotlib Python package is required

from pylab import *
import sys, math, random

pi=3.14
class Point:
    def __init__(self, coords, label=0,reference=None):
        self.coords = coords
        self.label=label
        self.n = len(coords)
        self.reference = reference
    def __repr__(self):
        return str(self.coords)
    
class Cluster:
    def __init__(self, points):
        if len(points) == 0: raise Exception("ILLEGAL: EMPTY CLUSTER")
        self.points = points
        self.n = points[0].n
        for p in points:
            if p.n != self.n: raise Exception("ILLEGAL: MULTISPACE CLUSTER")
        self.centroid = self.calculateCentroid()
    def __repr__(self):
        return str(self.points)
    def update(self, points):
        old_centroid = self.centroid
        self.points = points
        self.centroid = self.calculateCentroid()
        return getDistance(old_centroid, self.centroid)
    def calculateCentroid(self):
        centroid_coords = []
        leng=0.0
        for i in range(self.n):
            centroid_coords.append(0.0)
            for p in self.points:
                centroid_coords[i] = centroid_coords[i]+p.coords[i]
            centroid_coords[i] = centroid_coords[i]/len(self.points)
            leng=leng+centroid_coords[i]*centroid_coords[i]
        return Point(centroid_coords)
def kmeans(points, k, cutoff):
    initial = random.sample(points, k)
    clusters = []
    for p in initial: clusters.append(Cluster([p]))
    # Enter the program loop
    while True:
        # Make a list for each Cluster
        lists = []
        for c in clusters: lists.append([])
        # For each Point:
        for p in points:
            # Figure out which Cluster's centroid is the nearest
            smallest_distance = getDistance(p, clusters[0].centroid)
            index = 0
            for i in range(len(clusters[1:])):
                distance = getDistance(p, clusters[i+1].centroid)
                if distance < smallest_distance:
                    smallest_distance = distance
                    index = i+1
            lists[index].append(p)
        biggest_shift = 0.0
        for i in range(len(clusters)):
            shift = clusters[i].update(lists[i])
            biggest_shift = max(biggest_shift, shift)
        if biggest_shift < cutoff: break
    return clusters

def getDistance(a, b):
    if a.n != b.n: raise Exception("ILLEGAL: NON-COMPARABLE POINTS")
    ret = 0.0
    for i in range(a.n):
        ret = ret+(a.coords[i]-b.coords[i])*(a.coords[i]-b.coords[i])
    return math.sqrt(ret)

def makePoint(number,x):
    coords=[]
    for i in number: coords.append(i)
    print coords
    return Point(coords,x)
def main(args):
    color=['r','b','g']
    num_points, n, k, cutoff, mu1, sigma1,mu2,sigma2, mu3, sigma3 = 200, 2, 3, 1.05, 0,1, 3.09, 4.19, 5.180,6.27
    points = []
    #list of internal coordinates for RNA nucleotides, where last two angles correspond to pseudotorsions and are not included in clustering
    listo=[[170.651794,159.1395667,56.93418612,86.3791057,-135.5699695,-79.21703854,177.1991986,19.20520811,-134.5151728],[69.16577385,147.8340181,38.91342215,86.54882753,-144.3987039,-73.10926695,-177.0535493,-56.83436591,-129.7815607],[162.3669211,-173.7991977,51.0712218,83.83220048,-141.6136008,-63.89669023,-160.8715599,29.95224951,-128.8263937],[44.86654494,179.91284,62.93639671,82.55718699,-142.3025565,-77.21954148,179.9041668,-55.39807117,-142.6949167],[-107.2697882,106.0226816,135.8616715,83.58057472,-140.6667367,56.74096681,-179.5387131,162.901594,-18.81848723],[177.8141381,147.2033653,60.06559911,89.32307903,-126.1964024,-88.73784729,-179.5387131,27.78267871,-130.2565348],[171.1126437,148.1454953,52.54609793,83.44989926,-132.5193212,-71.82945478,-179.5387131,27.33370538,-121.664197],[166.4158655,171.8045348,53.30550631,83.40437276,-132.7079342,-70.64791001,-161.4589387,31.44748341,-126.8749168],[-117.8407581,-174.8823724,60.93730823,82.35619302,-152.095751,40.92042972,-157.4976706,172.6817493,-29.35156592],[130.5242842,-132.4673364,66.11368398,85.90739959,-155.9506941,-61.02409889,-169.3337951,35.07115741,-132.6097886],[176.5315955,152.5912146,53.2127572,89.56548989,-129.3388051,-84.74160451,-169.3337951,16.54161769,-129.7455965],[64.18302665,152.3336633,40.10393929,81.90555983,-152.6942867,-69.61898531,-169.3337951,-60.79801501,-139.2623916],[165.6465539,167.4833532,50.24255126,86.37732249,-139.9222323,-65.15563454,-170.3254074,25.25611293,-124.6670298],[81.49251317,-153.7036205,67.268386,89.64093479,-142.6517693,-59.25538762,-175.6926973,27.62920157,-116.8849982],[-155.8121469,159.2475252,49.83790127,87.23267568,-137.0013349,-77.07852508,170.6687379,32.65498787,-133.1198497],[163.3436466,60.44920685,-173.3073503,83.22511042,-179.0381298,63.17265803,-154.756137,-39.58326669,-115.4723939],[33.01065076,-172.4531089,44.45755097,81.62513419,-149.9321539,-66.43920183,179.0420324,-60.81484815,-141.9791824],[157.5994771,-178.8550777,53.682282,85.94795333,-144.8162794,-63.17081217,-169.8585022,26.46799207,-127.385562],[116.461504,151.5809028,31.95604113,83.33955064,-140.2757866,-53.90585732,-173.7337409,27.59209653,-114.003746],[116.461504,151.5809028,31.95604113,83.33955064,-140.2757866,-53.90585732,-173.7337409,27.59209653,-114.003746],[116.461504,151.5809028,31.95604113,83.33955064,-140.2757866,-53.90585732,-173.7337409,27.59209653,-114.003746],[116.461504,151.5809028,31.95604113,83.33955064,-140.2757866,-53.90585732,-173.7337409,27.59209653,-114.003746],[116.461504,151.5809028,31.95604113,83.33955064,-140.2757866,-53.90585732,-173.7337409,27.59209653,-114.003746],[116.461504,151.5809028,31.95604113,83.33955064,-140.2757866,-53.90585732,-173.7337409,27.59209653,-114.003746],[147.8431665,-174.7291648,64.07106978,91.29145957,-131.0750467,-75.11048499,-165.389685,33.95004398,-125.6142611],[-45.46533237,149.8619606,64.46398499,85.95075331,168.1026894,66.71454045,-156.2530161,179.9032091,-15.61075287],[170.2879316,138.3269549,51.27959825,90.28258958,-130.5393918,-85.43237134,-177.556839,17.93301412,-127.8627895],[41.61934878,173.9293262,49.45853542,85.89087385,-149.6436136,-73.87987816,178.1502188,-32.9007702,-142.1152013],[62.5108291,-141.4917693,132.1736551,85.87562596,-125.2654203,-76.38597732,166.4226843,36.76424424,-125.1382399],[167.6141387,170.8219818,48.26789376,80.83275491,-140.3175347,-59.82773484,-148.2037277,22.95172473,-126.2112909],[-58.33955372,172.1408306,43.60671927,85.73864853,-157.15256,38.16406839,-140.5386215,164.715489,-23.56187694],[-174.729614,120.450188,53.31716674,86.69181089,-130.4572044,-80.91104948,-179.2754757,29.32578618,-126.0780412],[147.5623341,179.4416328,70.59235049,90.47655729,-131.7565314,-79.66773327,-175.5040129,33.8007105,-131.4193537],[147.0368231,177.8081918,-171.9998258,74.1766767,-150.4697716,67.44022628,-171.2344459,160.2084625,-24.789999],[41.6203245,161.1427654,56.293864,88.77790049,-97.46852253,-138.6052621,-142.5547715,-45.15037686,-114.9538715],[152.6492858,-175.9983528,62.46496607,91.23656404,-150.5385184,-65.74948345,-156.611346,30.56859243,-128.7697528],[171.0935232,142.0084805,54.2411158,82.10729414,-140.458659,-64.35726106,-167.9168065,20.96180153,-123.6728512],[-175.7191927,158.9818451,171.4501479,83.55070732,-143.4501805,74.49643719,168.1369839,174.4546298,-14.16160294],[29.89748568,151.5054309,66.37798215,79.23347244,-138.494156,-79.83032716,-174.9975166,-48.92682,-139.3148987],[155.1088851,163.7202367,61.91897589,86.83338082,-134.347656,-71.45877072,-168.6291537,25.15497368,-126.5077686],[-169.1989994,178.1392765,52.39021422,88.27013197,-148.3565849,-67.70917319,-178.6480165,35.11156729,-132.7428032],[167.424232,162.1611442,52.55598079,83.26882602,-138.8607934,-64.42236577,-160.0811935,25.06953699,-124.8798898],[82.90723537,-173.180984,50.69964456,85.68317741,-145.7921909,-67.5867779,-168.9931034,15.90936017,-134.0668792],[-163.6146301,139.5530425,43.38307487,90.13761552,-144.6381104,-78.53592307,177.9281554,18.10452273,-130.7700517],[51.670803,-157.3550769,72.60921807,83.80392558,-151.2761073,-63.27473664,179.7518953,-54.48358821,-134.0453801],[157.9373969,-178.8522197,61.27164241,80.39882333,-128.7722168,-72.83841818,-165.3195692,36.35782335,-130.4996556],[108.0561116,-147.746787,60.50112444,88.40934225,-145.8829775,-61.32497988,-164.9599266,42.48645685,-123.9453141],[179.2292864,177.5343022,55.34209114,89.3752711,-149.1465443,-70.13301214,179.9015699,36.47602765,-134.231233],[47.8042735,171.9251009,49.04879468,86.82790829,-147.8191582,-70.93484321,-169.5672861,-50.68990395,-135.536931],[169.4186906,150.6052702,49.70815224,83.72891679,-140.8194747,-63.75873274,-170.2846261,20.72116693,-123.3763111],[116.5336241,-153.1202193,54.73236789,90.62178708,-159.7066445,-69.764078,-167.8623532,27.50614914,-109.4382361],[177.1957239,140.3012711,47.42921323,88.04494555,-147.1066458,-65.981297,-172.3625829,19.25440432,-124.1246516],[-98.84732397,-133.0896129,109.3858742,63.10138158,-132.707313,-90.75864858,-159.693067,-57.47173232,-116.6955338],[-65.19998572,-176.0509799,50.60962392,80.88510938,-152.137168,46.54246714,-156.7898263,173.0210448,-29.51231247],[-63.16255693,169.3498736,51.74881903,82.91372806,-150.1132253,59.23564298,-142.6137609,163.9483554,-19.18183452],[-63.07294637,167.3713683,55.87457436,84.4695223,-153.0560871,59.2221801,-152.6924733,168.803152,-15.01479932],[-179.6635712,152.4095742,49.13105038,85.38079483,-127.6353771,-84.21482102,-170.8819284,36.83486618,-132.2797081],[-69.51615285,177.7659619,60.00282212,88.06098915,-179.2455633,71.49491459,-156.5573513,170.6645154,-28.03709102],[-66.38897417,174.6375148,58.04450487,83.14071685,-151.2727594,50.3130081,-150.0439,171.6927478,-20.40832697],[155.5565546,-168.879762,56.07829512,88.98668286,-146.0743673,-60.11282898,-170.5093734,32.71078357,-124.2721252],[64.84644285,-153.7464555,179.1269546,82.07112828,-144.516523,51.6211949,-179.9743314,147.4293446,-19.81753959],[150.0831961,-173.5958867,60.16505209,88.19678137,-138.8851167,-74.02200582,-173.2610486,29.4541436,-132.1950938],[168.5817656,174.0532383,51.81896931,85.64217168,-143.1002702,-73.02954678,-163.924617,31.74513746,-134.0366665],[-76.0672061,172.3302123,60.52346077,83.36937162,-147.0790076,49.71060818,-157.5224276,164.2150972,-17.74716679],[168.8854533,167.0486598,51.85694093,84.10874718,-135.8396327,-69.06592497,-160.7547754,32.5917737,-127.5171079],[77.09415825,-177.5722575,53.55294661,88.83246299,-150.120048,-65.15616081,-177.7473934,-53.03312124,-131.0414486],[-66.04274434,178.4429108,57.1079967,82.46807558,-154.2992036,85.39846983,-162.3240495,170.7683737,-3.199995533],[168.1229469,138.9895519,59.69093788,81.90529817,-132.1663355,-68.97104092,-161.5714087,19.35673328,-121.481418],[107.4394664,-112.3428213,-172.2519047,85.45489764,-167.5841228,59.40938273,-171.9960098,157.3584617,-23.5399628],[177.5938707,148.1655072,52.85104046,82.31916832,-133.1431616,-77.60609891,-168.7439155,30.92885759,-130.6225867],[160.1433452,179.7330468,51.66158478,82.99251849,-143.944393,-62.64561406,-167.9077966,25.95605507,-129.50769],[-64.02807281,176.6824969,54.49192018,79.38132872,-148.1358213,46.18228127,-165.4614532,171.5225164,-26.86492217],[161.3802442,174.5784344,52.20644536,83.27746422,-139.5359196,-68.49118632,-166.8840316,21.48593632,-130.6767823],[-66.68543421,175.7020587,54.56178141,87.86018068,-157.6550144,45.5792249,-146.7149221,169.0050793,-21.66441775],[-66.14257029,178.9373397,52.84036525,78.10848759,-167.0681442,34.16354467,-154.1659318,167.0707991,-25.86903211],[79.62865205,135.8338971,45.89947285,82.58530785,-126.2743453,-84.96731593,-145.3784527,-56.39521069,-127.5793238],[48.91293847,177.4874274,53.31516054,84.96620847,-147.8604684,-69.5702505,-179.8882672,-55.30863093,-137.5823489],[-59.72441122,172.1518022,48.9613666,77.19290926,-150.7511038,49.43189592,-158.7681975,164.0573992,-24.99639339],[35.85049896,-146.242977,56.09529516,82.31675599,-155.1675168,-59.45476986,10.6692319,-38.21734598,-135.8501161],[178.1884097,158.2566682,44.84857362,84.80076008,-162.4973175,-60.8831814,-148.5857402,35.93556401,-116.3043621],[165.0964108,158.0363901,51.53557684,83.5657095,-125.9505787,-76.05711279,-156.709955,21.52079186,-126.7686491],[-64.14367477,173.5303525,52.40359136,83.83296804,-163.2293145,64.92363545,-146.9686138,163.8906193,-14.35819373],[171.7779009,171.5913575,51.35859233,82.1241308,-145.218904,-61.97117618,-157.6939463,35.96513347,-129.870564],[-53.66837082,165.4355424,51.25851823,83.43530357,-151.7908257,53.84223401,-149.1487198,168.3824762,-17.09749234],[168.6047635,163.3020749,53.19662112,82.87697398,-144.5268794,-64.06026572,-164.3440258,29.41822935,-129.0930602],[51.22741167,-166.2027871,56.08735814,89.24087629,-111.8243728,-80.64714749,164.9310038,-55.1591224,-115.173254],[-79.4790582,162.7223999,58.0128065,86.39235853,3.84663645,-126.1822481,-165.9402829,-179.5723194,-9.861520426],[153.2410959,174.0469296,55.52293585,81.64592663,-138.5408843,-61.29439564,-170.1851541,15.58223012,-124.5563355],[172.7651175,148.4994554,48.36669998,85.45597414,-132.9083473,-76.08230114,-140.1074902,24.9975636,-127.5016415],[-69.02495916,-178.5963854,51.97886152,81.23014822,-154.1936341,50.16060628,-147.0205404,167.3870748,-26.41857862],[173.0776744,166.9321936,46.90246345,80.24501958,-140.9410715,-65.33474857,-168.1221545,32.05883609,-131.1670382],[-60.6389165,173.0337128,51.1028719,84.41814152,-150.4433985,58.83851328,-148.5468781,168.4133577,-19.17131109],[176.972709,143.3269014,49.35222343,86.20903157,-145.8815886,-65.04942346,-167.8914996,20.5714281,-123.7640495],[-59.51837869,168.7888324,53.77261205,82.64994835,-142.0682048,49.33168218,-146.1801374,168.2202613,-18.93716293],[-60.64892094,169.3743107,55.63359529,74.81399342,-168.1201918,56.0299993,-168.8235267,166.060473,-2.341689057],[165.9288974,171.3267538,51.14727659,83.49275064,-132.435762,-70.18342788,-162.8378516,30.74706139,-127.1181551],[-70.15346654,174.2831754,55.62414311,82.9303529,-159.2078551,51.70385303,-165.7835163,160.9207378,-14.90212716],[169.4431189,147.1273537,51.02150401,83.48576029,-139.048043,-72.32626849,-173.4286118,20.6211034,-129.3513782],[170.2855232,164.8463806,51.81112765,85.18660803,-142.1569103,-70.55105525,-171.1779261,31.2049674,-131.4204566],[175.1822858,148.5321372,53.81205151,85.66118077,-140.4816527,-70.68564504,-159.4612515,30.39457792,-127.7584636],[-62.94441228,169.8522428,54.42579447,82.35607332,-146.1651526,46.0477472,-159.1191927,167.354593,-26.14110919],[-73.63991955,163.0857697,59.5993096,83.50043797,-148.0164308,51.28379853,-151.9719749,152.1961907,-15.82665117],[158.4472017,164.3549515,51.14839459,87.93469441,-122.5982437,-82.0498976,-146.7937784,23.77696631,-127.7884953],[-104.3618002,-135.5456305,160.019502,81.3537338,-135.0130165,-66.11424908,173.4279182,-45.75668636,-136.8432054],[-61.70632557,-179.5878266,54.88487472,82.85153528,-158.6949897,54.92937023,-163.4739529,177.1273483,-23.35294365],[54.16521266,-152.4854415,58.89670695,88.98542359,-137.3390163,-67.70030059,174.8351278,-36.54920558,-124.0109487],[56.46961897,178.9829189,48.28217832,85.51642497,-159.6679273,-63.58112792,-168.6841695,-53.44034669,-140.0580049],[-62.01587851,166.2868673,54.61089695,80.70416975,-148.5151871,33.78919211,-154.9512533,165.7887406,-28.29495764],[176.3414114,133.180682,56.66043636,84.75572052,-138.8454601,-68.24104153,-175.8961828,19.93437392,-122.4128841],[56.77584898,136.064015,50.06296295,83.17585205,-137.2467708,-67.72743743,-171.8702439,-60.60244048,-120.7166176],[-57.60977318,167.8959241,53.82990441,80.85689076,-149.9982341,49.4218073,-164.5637625,171.2031615,-22.70077697],[-64.4809651,167.6913967,57.64767982,84.44554405,-153.3039235,51.5296288,-147.0164802,166.227106,-17.51699959],[-56.37485797,162.8179792,52.75431258,81.34275313,-155.4014138,64.40867259,-152.7029977,159.1633906,-17.93933383],[166.6597661,151.5511054,52.98709275,86.56023363,-142.8180869,-68.0207057,-163.086693,19.40125704,-126.0364275],[80.08184407,145.9438752,49.8533857,81.80752892,-139.5173947,-72.07557768,-172.8605135,-37.21976418,-129.7920409],[87.47241174,-131.0635418,-163.4647299,82.69277332,-163.7757005,123.7001772,-158.827539,157.3212395,-2.104434581],[-70.5432745,172.4892402,42.75329489,74.330854,-173.9175426,58.21790792,-155.248759,150.8691011,-8.951450253],[68.92409625,-168.4142892,55.87372903,85.23538094,-142.2415856,-61.58995946,179.2380454,-51.71666432,-124.0910347],[167.2590531,165.2985163,48.52122429,86.60334642,-131.931016,-76.8748332,-140.0808014,29.78575994,-129.436231],[168.3219083,139.7086203,54.65417072,82.85468869,-134.3101517,-68.58003994,-155.1021022,15.64777224,-122.2267842],[-68.62096826,176.2356813,54.38499065,84.30077668,-145.6001987,61.94035083,-151.9447273,168.2969456,-17.34449655],[-55.23795245,171.5033718,53.07192557,80.60486229,-144.1718056,54.93057777,-154.1113164,169.2665383,-18.16707784],[158.6071484,148.9076904,60.47414568,86.50948019,-131.2467697,-73.16884703,-174.4047506,18.90144297,-124.5628124],[-71.04857573,-178.8648111,53.40438087,76.39438009,-163.2972389,41.30381456,-154.4478227,165.207786,-17.24226487],[115.5835264,165.0855709,50.84909607,86.32634578,-153.3296823,-62.72136142,-163.942724,-39.37378501,-130.8413471],[-61.65203947,170.7637759,56.92295154,82.86930424,-148.7926852,48.90519806,-151.5503427,175.9914838,-22.4944193],[-62.77875563,158.6105256,56.12058179,81.7606815,-154.9866695,58.22977948,-149.2643696,160.2818113,-17.86425891],[177.7513445,134.7843064,-178.50269,80.26397007,-147.7276273,108.4780142,-166.2910816,168.7025007,-18.95582616],[49.42110446,177.2099723,51.77788917,83.65247505,-164.501592,-56.57304492,-175.6618402,-47.25912814,-132.8028295],[159.068215,175.7099639,56.72149623,79.56553258,-121.3131491,-66.86385591,-171.8315507,30.71519457,-125.8478994],[67.68800294,-145.3396195,73.09750399,94.655059,-145.8013322,-63.22777478,175.2435249,21.56147664,-112.9915055],[173.1698122,130.5074247,53.66036941,88.8773226,-122.4303527,-77.28332236,-168.7108834,17.28180021,-118.713594],[98.78209144,142.5760548,70.07517854,87.99059755,-168.3108123,-58.9842793,174.6208385,-39.67058146,-134.5216058],[171.62111,169.2941238,53.63623383,83.25831211,-145.2538839,-63.86613401,-153.077735,36.56910928,-130.0803317],[176.0461306,149.8264913,52.64155165,83.52224588,-131.8957431,-76.08588783,-176.0367091,34.81085095,-130.9581113],[179.505845,150.1053524,39.92065261,86.83192701,-142.7954818,-68.11750924,-162.7586219,25.99743452,-127.6696448],[171.9151846,176.6275385,47.53141477,83.61805577,-130.3611666,-72.09292389,-175.7453615,36.79660017,-129.7960121],[53.07934838,138.051837,57.27358282,85.06986109,-149.3318916,-60.23737698,175.9695435,-52.98672993,-122.0808679],[176.6573781,146.832245,43.33171165,82.63654838,-138.4267372,-67.26691193,175.0151648,17.88710092,-125.7181423],[175.0733713,136.251813,53.03363819,85.1755108,-144.1918129,-67.56594629,-162.8531039,19.66441487,-124.2255666],[167.9706787,-175.118594,49.37105104,89.20363853,-148.8169754,-65.62314743,-154.7278839,38.40319214,-131.9676428],[40.10382409,-167.7041569,52.80214568,84.53910486,-145.3137155,-74.35404587,177.3840622,-37.9478712,-141.7355666],[169.1697225,167.4350391,50.37074456,82.2411019,-136.6865614,-71.2070124,-161.47734,22.28002902,-130.8874128],[62.45000189,166.1831515,75.97782739,87.43392757,-147.1141008,-75.87789068,177.2553359,-38.03171285,-140.7192222],[-115.8301293,-131.97212,53.04442466,81.63937534,-179.5831307,95.65613766,-159.8269715,149.4519537,-12.34462271],[142.8314461,-127.7783032,165.0140794,88.46297147,-159.8234996,50.58352713,-155.3439253,152.2838269,-7.859843882],[-57.07884649,164.7236003,53.81199474,86.28300247,-151.0184148,30.89923744,-149.0826432,167.3764198,-24.85101542],[-66.58926361,175.840966,49.82844931,80.80562684,-153.7258652,44.07372006,-152.2456736,162.4020343,-25.31512781],[-60.89800964,154.2416403,54.34761579,84.47420283,-154.1897763,20.59823021,-139.399923,158.6540901,-25.69046207],[-66.32366202,169.2028994,48.6743738,81.9936609,-157.0442904,45.4647737,-144.9519024,155.1915933,-27.06568675],[109.0317413,164.4464072,57.45768327,86.27968339,-146.4223982,-77.10776536,-178.8328648,-38.16922341,-140.3424548],[43.35621772,174.9490838,52.55483769,87.00692239,-137.7814518,-69.87796466,-143.2344328,-51.95183671,-127.1247982],[115.8349398,145.6064468,53.36836674,80.59218029,-143.7838005,-77.76632107,177.0316509,-39.47482077,-140.1293808],[-65.46177054,167.9524976,53.99572769,85.92268513,-139.1087877,40.92437438,-148.9959964,158.9860402,-25.20568873],[165.2028768,160.1363677,54.00786176,87.54050418,-125.6905284,-81.86379573,-155.4607197,32.70158174,-129.4464732],[-71.54580604,179.4682728,54.59543484,85.42262974,-153.4435791,48.9506732,-156.232506,163.0965397,-23.40098649],[-179.5279037,131.6290726,51.55029756,84.81615793,-137.2586235,-71.53931349,-154.0763291,20.96085553,-123.7396207],[174.5001532,151.4585184,45.06948486,90.29444673,-123.3386565,-87.42579579,-160.3674711,29.58489241,-128.5714521],[121.3671276,124.6592633,47.21154769,79.76204069,-150.5366027,-67.35181162,-173.7383815,-46.34584342,-130.80353],[-66.63877291,-179.7985914,55.55054041,87.51268186,-146.9788271,47.02942129,-153.0817956,175.5308924,-24.88222498],[-71.79782718,-166.8892359,54.19335186,84.35243407,-174.8127303,95.71877993,-153.8109538,176.2376076,-13.0224719],[76.05030287,163.9463153,56.02038534,86.01762628,-122.2596578,-78.36673976,-144.4430104,-54.82086142,-124.8603039],[-57.95912445,160.2034204,54.89957345,83.18870617,-146.1115574,46.50361048,-151.481137,157.561916,-19.64712776],[-178.291156,135.3119857,55.23385584,89.1493139,-120.498172,-90.24765677,-138.2756477,37.61380764,-131.3655104],[-57.76246447,168.6167008,47.19077172,85.46681204,-167.7849295,48.66113942,-132.7400767,166.0866628,-25.86130709],[-60.83577557,157.0036866,60.01226455,82.34887948,-162.821618,45.78711186,-143.7753062,156.2652212,-28.977289],[178.7717042,143.0027863,48.84289053,85.28521194,-135.4253422,-75.2883925,-165.6827573,27.52349969,-128.5380628],[178.125968,130.5368597,52.06681581,87.29908865,-132.5728665,-79.66169819,-173.9513824,20.37567527,-125.1796359],[178.0129878,169.7200728,50.06849979,80.66192728,-147.3117374,-63.32441506,-153.6153119,39.2576977,-134.5174987],[119.3616822,138.847703,44.55074273,83.47398119,-155.2240735,-47.09050785,-162.4141335,-42.2297665,-115.0202686],[-55.42547875,174.6809584,52.33867052,83.51910081,-141.4172728,62.89298417,-146.2866222,179.3032687,-19.07024752],[154.5485612,157.6875425,60.06283192,80.74405124,-135.4643506,-61.16754858,-163.1341864,15.82035847,-123.0233929],[-55.95395752,170.7879819,49.47674504,83.35658486,-145.0477286,45.37292065,-126.6216292,172.1780064,-23.67826271],[59.49049128,156.7405394,52.42441819,83.5781852,-140.9224813,-76.29366342,-179.8996035,-36.33458857,-136.3902954],[-166.3052439,123.2773532,59.6611367,93.61967801,-102.1338771,-153.2320392,-179.8996035,30.66118858,-116.7110161],[-79.0748199,-166.388783,142.2364051,90.94913609,-74.37855059,-152.4891732,-179.8996035,-48.96791616,-139.9536056],[104.9674677,-168.7530947,94.41335764,88.22870527,-112.4691248,-68.1500383,173.4697547,16.33008746,-122.4601417],[153.8708255,174.5623643,-179.3288375,79.89219331,-152.6746136,66.8079766,-170.0342247,159.489564,-20.83472743],[69.43521405,144.7162296,49.60719718,85.21569146,-151.4896359,-60.83812502,-156.9498667,-59.92425989,-129.637189],[69.43521405,144.7162296,49.60719718,85.21569146,-151.4896359,-60.83812502,-156.9498667,-59.92425989,-129.637189],[69.43521405,144.7162296,49.60719718,85.21569146,-151.4896359,-60.83812502,-156.9498667,-59.92425989,-129.637189],[69.43521405,144.7162296,49.60719718,85.21569146,-151.4896359,-60.83812502,-156.9498667,-59.92425989,-129.637189],[69.43521405,144.7162296,49.60719718,85.21569146,-151.4896359,-60.83812502,-156.9498667,-59.92425989,-129.637189],[32.64326631,170.8712576,54.26970608,87.11633799,-149.8313575,-61.51747108,178.3487321,-57.61521633,-129.7599826],[155.2207344,-170.8430681,52.18176403,84.1593002,-132.1857657,-79.25904349,-169.1139018,15.04630579,-133.8416454],[-124.4338999,-177.5966318,69.51291812,97.69678956,-34.58309258,-54.88048164,-143.7744736,155.1691047,-28.1965128],[152.2521456,-178.0965643,57.73936998,86.09246784,-145.4509251,-61.7552608,-173.3727481,16.03729555,-126.1891255],[-29.96698106,-125.1136195,76.74432087,89.54398381,-160.6616898,-63.62436217,179.8240057,-52.36492102,-128.056018],[166.6033064,166.6630184,47.54887068,85.57427448,-130.4539092,-70.67237608,-153.3144162,27.21252779,-120.8517396],[122.6222861,-177.0647681,63.69892541,88.5890247,-126.2090803,-73.59631667,-178.8754512,23.25658629,-119.5605346]]
    no=0
    dico={}
    for i in listo:
      no=no+1  
      points.append(makePoint(i[:-2],no))
      dico[no]=i[-2:]
    clusters = kmeans(points, k, cutoff)
    print "\nPOINTS:"
    print "\nCLUSTERS:"
    coo=0
    coo=0
    allo=0
    clo_as=[]
    clo_real=[]
    loba=0
    for c in clusters:
       loba=loba+1
       x2 = []
       y2= []
       labels=[]
       ha1=0
       ha2=0
       ha3=0
       print c
       for el in c.points:
         clo_as.append(loba)
         labels=labels+[el.label]
         x2=x2+[dico[el.label][0]]
         y2=y2+[dico[el.label][1]]
         if dico[el.label][0]<200 and dico[el.label][0]>140:
             ha1=ha1+1
             clo_real.append(1)
         elif dico[el.label][0]<50 and dico[el.label][0]>0:
             ha2=ha2+1
             clo_real.append(2)
         else:
             ha3=ha3+1
             clo_real.append(3)
       allo=allo+max([ha1,ha2,ha3])             
       print "C:", c.points
  
       
       if coo<100:
         scatter(x2,y2, c=color[coo])
       coo=coo+1
    allo=allo
    print "purity", float(allo)*100/len(listo)
    show()
if __name__ == "__main__": main(sys.argv)
